<template>
  <div class="multiselect-checkbox">
    <div @click="toggleDropdown" class="dropdown-toggle">{{ selectedItemsString }}</div>
    <div v-if="isOpen" class="dropdown-menu">
      <input type="text" v-model="searchQuery" placeholder="Search" class="search-input" />
      <div v-for="(item, index) in filteredMenuItems" :key="index">
        <input type="checkbox" :id="item.value" :value="item.value" :disabled="shouldDisable(item)"
          v-model="selectedValues" @change="updateSelectedValues" />
        <label :for="item.value">{{ item.label }}</label>
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">
import { ref,  computed } from "vue";

const props = defineProps({
  menuItems: {
    type: Array<Record<string, string>>,
    default: () => [],

  },
  modelValue: {
    type: Array,
    default: () => [],
  },
  maxSelections: {
    type: Number,
    default: 0,
    required: true,

  },
  minSelections: {
    type: Number,
    default: 0,
    required: true,
  },
  buttonText: {
    type: String,
    default: "Geographies selected",
    required: false,
  },
});

const emit = defineEmits(["update:modelValue"]);

const selectedValues = ref([...props.modelValue]);
const isOpen = ref(false);
const searchQuery = ref('');

const updateSelectedValues = () => {
  if (selectedValues.value.length >= props.minSelections) {
    emit("update:modelValue", selectedValues.value);
  }
  else if (selectedValues.value.length == 0) {
    emit("update:modelValue", []);
  }
};

const shouldDisable = (item: Record<string, string>) => {
  return (
    selectedValues.value.length >= props.maxSelections &&
    !selectedValues.value.includes(item.value)
  );
};

const toggleDropdown = () => {
  isOpen.value = !isOpen.value;
};

const selectedItemsString = computed(() => {
  const text = props.buttonText + " - " + "(" + selectedValues.value.length + " of " + props.maxSelections + ")";
  return text;
});

const filteredMenuItems = computed(() => {
  if (!searchQuery.value) {
    return props.menuItems;
  }

  return props.menuItems.filter(item =>
    item.label.toLowerCase().includes(searchQuery.value.toLowerCase())
  );
});
</script>

<style scoped lang="scss">
@import '@/scss/multiselectcheckbox';
</style>
